import React from 'react';
import { IconType } from '../Icon';
import { BaseItemProps, BaseMenuProps } from './BaseMenu';
export declare const MenuItem: import("styled-components").StyledComponent<"div", import("styled-components").DefaultTheme, {
    readonly divider?: boolean | undefined;
    readonly danger?: boolean | undefined;
    readonly compact: boolean;
}, never>;
export interface MenuItemProps extends Omit<BaseItemProps, 'component' | 'keyboardSelect'> {
    readonly icon?: IconType;
    readonly label: string;
    readonly divider?: boolean;
    readonly danger?: boolean;
    /**
     * Override theme's default setting for `compact` if set.
  
     */
    readonly compact?: boolean;
}
interface MenuProps extends Omit<BaseMenuProps, 'components'> {
    /**
     * An array of items in the drop down menu.
     */
    readonly items: ReadonlyArray<MenuItemProps>;
    /**
     * Override theme's default setting for `compact` if set.
  
     */
    readonly compact?: boolean;
}
/**
 * Menu
 *
 * Forwards props to BaseMenu
 */
export declare const Menu: React.NamedExoticComponent<MenuProps>;
export {};
