import { SimpleToast, ActionToast, ProgressToast, BaseToastValue } from './context';
export declare type Toast = SimpleToast | ActionToast;
declare type ToastCreator<T = Toast> = (toast: T) => BaseToastValue;
declare type SimpleToastCreator = ToastCreator<SimpleToast>;
declare type ActionToastCreator = ToastCreator<ActionToast>;
declare type ProgressToastCreator = ToastCreator<ProgressToast>;
export declare const createSuccessToast: SimpleToastCreator;
export declare const createErrorToast: SimpleToastCreator;
export declare const createWarningToast: SimpleToastCreator;
export declare const createInfoToast: SimpleToastCreator;
export declare const createActionToast: ActionToastCreator;
export declare const createLoadingToast: SimpleToastCreator;
export declare const createProgressToast: ProgressToastCreator;
export {};
