"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.createProgressToast = exports.createLoadingToast = exports.createActionToast = exports.createInfoToast = exports.createWarningToast = exports.createErrorToast = exports.createSuccessToast = void 0;

var _react = _interopRequireDefault(require("react"));

var _styledComponents = _interopRequireWildcard(require("styled-components"));

var _practicalReactComponentsIcons = require("practical-react-components-icons");

var _Link = require("../Link");

var _Icon = require("../Icon");

var _Typography = require("../Typography");

var _designparams = require("../designparams");

var _Spinner = require("../Spinner");

var _Progress = require("../Progress");

function _getRequireWildcardCache() { if (typeof WeakMap !== "function") return null; var cache = new WeakMap(); _getRequireWildcardCache = function _getRequireWildcardCache() { return cache; }; return cache; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

var ToastLabel = (0, _styledComponents.default)(_Typography.Typography).attrs({
  variant: 'chip-tag-text'
}).withConfig({
  displayName: "toastCreators__ToastLabel",
  componentId: "sc-128zro4-0"
})(["height:100%;", " ", " ", ""], (_ref) => {
  var {
    hasCloseButton
  } = _ref;
  return !hasCloseButton ? (0, _styledComponents.css)(["padding:0 ", ";"], _designparams.spacing.large) : (0, _styledComponents.css)(["padding-left:", ";"], _designparams.spacing.large);
}, (_ref2) => {
  var {
    hasEmphasis: emphasis
  } = _ref2;
  return emphasis ? (0, _styledComponents.css)(["font-weight:", ";"], (_ref3) => {
    var {
      theme
    } = _ref3;
    return theme.font.fontWeight.semibold;
  }) : undefined;
}, (_ref4) => {
  var {
    isError
  } = _ref4;
  return isError ? (0, _styledComponents.css)(["color:", ";"], (_ref5) => {
    var {
      theme
    } = _ref5;
    return theme.color.textError();
  }) : (0, _styledComponents.css)(["color:", ";"], (_ref6) => {
    var {
      theme
    } = _ref6;
    return theme.color.text01();
  });
});

var IconWrapper = _styledComponents.default.div.withConfig({
  displayName: "toastCreators__IconWrapper",
  componentId: "sc-128zro4-1"
})(["height:", ";width:", ";display:flex;align-items:center;justify-content:center;"], _designparams.iconSize.medium, _designparams.iconSize.medium);

var Message = (0, _styledComponents.default)(_Typography.Typography).attrs({
  variant: 'chip-tag-text'
}).withConfig({
  displayName: "toastCreators__Message",
  componentId: "sc-128zro4-2"
})(["white-space:normal;"]);
var SuccessNotificationIconColor = (0, _styledComponents.default)(IconWrapper).withConfig({
  displayName: "toastCreators__SuccessNotificationIconColor",
  componentId: "sc-128zro4-3"
})(["color:", ";"], (_ref7) => {
  var {
    theme
  } = _ref7;
  return theme.color.elementSuccess();
});
var WarningIconColor = (0, _styledComponents.default)(IconWrapper).withConfig({
  displayName: "toastCreators__WarningIconColor",
  componentId: "sc-128zro4-4"
})(["color:", ";"], (_ref8) => {
  var {
    theme
  } = _ref8;
  return theme.color.elementWarning();
});
var InfoIconColor = (0, _styledComponents.default)(IconWrapper).withConfig({
  displayName: "toastCreators__InfoIconColor",
  componentId: "sc-128zro4-5"
})(["color:", ";"], (_ref9) => {
  var {
    theme
  } = _ref9;
  return theme.color.text04();
});
var ErrorIconColor = (0, _styledComponents.default)(IconWrapper).withConfig({
  displayName: "toastCreators__ErrorIconColor",
  componentId: "sc-128zro4-6"
})(["color:", ";"], (_ref10) => {
  var {
    theme
  } = _ref10;
  return theme.color.elementError();
});
var ActionIconColor = (0, _styledComponents.default)(IconWrapper).withConfig({
  displayName: "toastCreators__ActionIconColor",
  componentId: "sc-128zro4-7"
})(["color:", ";"], (_ref11) => {
  var {
    theme
  } = _ref11;
  return theme.color.elementPrimary();
});

/*
 * Success toast
 */
var createSuccessToast = (_ref12) => {
  var {
    label,
    message
  } = _ref12,
      rest = _objectWithoutProperties(_ref12, ["label", "message"]);

  var labelComponent = /*#__PURE__*/_react.default.createElement(ToastLabel, {
    hasCloseButton: false,
    isError: false,
    hasEmphasis: message !== undefined
  }, label);

  var icon = /*#__PURE__*/_react.default.createElement(SuccessNotificationIconColor, null, /*#__PURE__*/_react.default.createElement(_Icon.Icon, {
    icon: _practicalReactComponentsIcons.CheckIcon
  }));

  var messageComponent = message !== undefined ? /*#__PURE__*/_react.default.createElement(Message, null, message) : undefined;
  return _objectSpread({
    icon,
    label: labelComponent,
    message: messageComponent,
    hasCloseButton: false
  }, rest);
};
/*
 * Error toast
 */


exports.createSuccessToast = createSuccessToast;

var createErrorToast = (_ref13) => {
  var {
    label,
    message
  } = _ref13,
      rest = _objectWithoutProperties(_ref13, ["label", "message"]);

  var labelComponent = /*#__PURE__*/_react.default.createElement(ToastLabel, {
    hasCloseButton: true,
    isError: true,
    hasEmphasis: message !== undefined
  }, label);

  var icon = /*#__PURE__*/_react.default.createElement(ErrorIconColor, null, /*#__PURE__*/_react.default.createElement(_Icon.Icon, {
    icon: _practicalReactComponentsIcons.AlertIcon
  }));

  var messageComponent = message !== undefined ? /*#__PURE__*/_react.default.createElement(Message, null, message) : undefined;
  return _objectSpread({
    icon,
    label: labelComponent,
    message: messageComponent
  }, rest);
};
/*
 * Warning toast
 */


exports.createErrorToast = createErrorToast;

var createWarningToast = (_ref14) => {
  var {
    label,
    message
  } = _ref14,
      rest = _objectWithoutProperties(_ref14, ["label", "message"]);

  var labelComponent = /*#__PURE__*/_react.default.createElement(ToastLabel, {
    hasCloseButton: true,
    isError: false,
    hasEmphasis: message !== undefined
  }, label);

  var icon = /*#__PURE__*/_react.default.createElement(WarningIconColor, null, /*#__PURE__*/_react.default.createElement(_Icon.Icon, {
    icon: _practicalReactComponentsIcons.WarningIcon
  }));

  var messageComponent = message !== undefined ? /*#__PURE__*/_react.default.createElement(Message, null, message) : undefined;
  return _objectSpread({
    icon,
    label: labelComponent,
    message: messageComponent
  }, rest);
};
/*
 * Info toast
 */


exports.createWarningToast = createWarningToast;

var createInfoToast = (_ref15) => {
  var {
    label,
    message
  } = _ref15,
      rest = _objectWithoutProperties(_ref15, ["label", "message"]);

  var labelComponent = /*#__PURE__*/_react.default.createElement(ToastLabel, {
    hasCloseButton: true,
    isError: false,
    hasEmphasis: message !== undefined
  }, label);

  var icon = /*#__PURE__*/_react.default.createElement(InfoIconColor, null, /*#__PURE__*/_react.default.createElement(_Icon.Icon, {
    icon: _practicalReactComponentsIcons.InfoIcon
  }));

  var messageComponent = message !== undefined ? /*#__PURE__*/_react.default.createElement(Message, null, message) : undefined;
  return _objectSpread({
    icon,
    label: labelComponent,
    message: messageComponent
  }, rest);
};
/*
 * Action toast
 *
 * Has a custom action icon (primary color),
 * and a clickable action link.
 */


exports.createInfoToast = createInfoToast;
var LinkWrapper = (0, _styledComponents.default)(_Typography.Typography).attrs({
  variant: 'chip-tag-text'
}).withConfig({
  displayName: "toastCreators__LinkWrapper",
  componentId: "sc-128zro4-8"
})(["padding:0 ", ";font-weight:bold;"], _designparams.spacing.large);

var createActionToast = (_ref16) => {
  var {
    label,
    message,
    action
  } = _ref16,
      rest = _objectWithoutProperties(_ref16, ["label", "message", "action"]);

  var labelComponent = /*#__PURE__*/_react.default.createElement(_react.default.Fragment, null, /*#__PURE__*/_react.default.createElement(ToastLabel, {
    hasCloseButton: true,
    isError: false,
    hasEmphasis: false
  }, label), /*#__PURE__*/_react.default.createElement(LinkWrapper, null, /*#__PURE__*/_react.default.createElement(_Link.Link, action.link, action.text)));

  var icon = /*#__PURE__*/_react.default.createElement(ActionIconColor, null, /*#__PURE__*/_react.default.createElement(_Icon.Icon, {
    icon: action.icon
  }));

  var messageComponent = message !== undefined ? /*#__PURE__*/_react.default.createElement(Message, null, message) : undefined;
  return _objectSpread({
    icon,
    label: labelComponent,
    message: messageComponent
  }, rest);
};
/*
 * Loading toast
 */


exports.createActionToast = createActionToast;

var LoadingIconSize = _styledComponents.default.div.withConfig({
  displayName: "toastCreators__LoadingIconSize",
  componentId: "sc-128zro4-9"
})(["transform:scale(0.75);"]);

var createLoadingToast = (_ref17) => {
  var {
    label,
    message
  } = _ref17,
      rest = _objectWithoutProperties(_ref17, ["label", "message"]);

  var labelComponent = /*#__PURE__*/_react.default.createElement(ToastLabel, {
    hasCloseButton: true,
    isError: false,
    hasEmphasis: message !== undefined
  }, label);

  var icon = /*#__PURE__*/_react.default.createElement(LoadingIconSize, null, /*#__PURE__*/_react.default.createElement(_Spinner.Spinner, null));

  var messageComponent = message !== undefined ? /*#__PURE__*/_react.default.createElement(Message, null, message) : undefined;
  return _objectSpread({
    icon,
    label: labelComponent,
    message: messageComponent
  }, rest);
};
/*
 * Progress toast
 */


exports.createLoadingToast = createLoadingToast;

var ProgressWrapper = _styledComponents.default.div.withConfig({
  displayName: "toastCreators__ProgressWrapper",
  componentId: "sc-128zro4-10"
})(["display:flex;align-items:center;padding-left:", ";"], _designparams.spacing.large);

var createProgressToast = (_ref18) => {
  var {
    label,
    message,
    progress
  } = _ref18,
      rest = _objectWithoutProperties(_ref18, ["label", "message", "progress"]);

  var labelComponent = /*#__PURE__*/_react.default.createElement(_react.default.Fragment, null, /*#__PURE__*/_react.default.createElement(ToastLabel, {
    hasCloseButton: true,
    isError: false,
    hasEmphasis: message !== undefined
  }, label), /*#__PURE__*/_react.default.createElement(ProgressWrapper, null, /*#__PURE__*/_react.default.createElement(_Progress.Progress, progress)));

  var icon = /*#__PURE__*/_react.default.createElement(LoadingIconSize, null, /*#__PURE__*/_react.default.createElement(_Spinner.Spinner, null));

  var messageComponent = message !== undefined ? /*#__PURE__*/_react.default.createElement(Message, null, message) : undefined;
  return _objectSpread({
    icon,
    label: labelComponent,
    message: messageComponent
  }, rest);
};

exports.createProgressToast = createProgressToast;